﻿using System;
using System.Linq;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

public class UIScaler : Mod
{
    public static float size = 1f;

    private void Start()
    {
        SceneManager.sceneLoaded += new UnityAction<Scene, LoadSceneMode>(OnSceneLoaded);
        if (PlayerPrefs.HasKey("rml.savedUIScale"))
        {
            size = float.Parse(PlayerPrefs.GetString("rml.savedUIScale"));
            SetUIScale();
        }
    }

    private void OnSceneLoaded(Scene scene, LoadSceneMode mode)
    {
        SetUIScale();
    }

    [ConsoleCommand(name: "setuiscale", docs: "Set the UI Scale.")]
    public static void CommandSetScale(string[] args)
    {
        if (args.Length != 1)
        {
            Debug.LogError("Invalid arguments! Syntax: setuiscale 0.5");
        }
        else
        {
            float num = float.Parse(args[0].ToLower().Replace('.', ','));
            bool flag2 = (double)num >= 0.5 && num <= 5f;
            if (flag2)
            {
                PlayerPrefs.SetString("rml.savedUIScale", args[0].ToLower().Replace('.', ','));
                size = num;
                SetUIScale();
            }
            else
            {
                Debug.LogWarning("Invalid scale, must be between 0.5 and 5!");
            }
        }
    }

    private static void SetUIScale()
    {
        CanvasScaler[] array = FindObjectsOfType<CanvasScaler>();
        foreach (CanvasScaler canvasScaler in array)
        {
            canvasScaler.referenceResolution = new Vector2((float)Screen.width * size, (float)Screen.height * size);
        }
    }

    public void OnModUnload()
    {
        SceneManager.sceneLoaded -= new UnityAction<Scene, LoadSceneMode>(OnSceneLoaded);
        Debug.Log("UIScaler has been unloaded!");
    }
}
